import * as React from 'react';
import type { Options } from 'from-to.js';
import type { WaveConfig } from './createWave';
type SupportedMotionConfig = WaveConfig;
export type WaveTransition = Options<unknown>;
export type MotionConfig = {
    [P in keyof SupportedMotionConfig]?: (WaveTransition & {
        value: NonNullable<SupportedMotionConfig[P]>;
    }) | SupportedMotionConfig[P];
};
export interface MotionWaveProps extends React.CanvasHTMLAttributes<HTMLCanvasElement> {
    initialConfig: WaveConfig;
    motionConfig?: MotionConfig;
}
export declare const MotionWave: React.MemoExoticComponent<React.ForwardRefExoticComponent<MotionWaveProps & React.RefAttributes<unknown>>>;
export {};
