"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MotionWave = void 0;
const React = __importStar(require("react"));
const hook_1 = require("./hook");
exports.MotionWave = React.memo(React.forwardRef((props, ref) => {
    const { width = innerWidth, height = innerHeight, initialConfig, motionConfig, ...restProps } = props;
    const defaultConfig = React.useMemo(() => initialConfig, []);
    const [canvasRef, canvasHandler] = (0, hook_1.useWave)(defaultConfig, ref);
    const motionMap = React.useRef({});
    (0, hook_1.useLayoutEffect)(() => {
        if (motionConfig && canvasHandler.current) {
            Object.entries(motionConfig).forEach(([key, config]) => {
                const motionKey = key;
                const currentValue = canvasHandler.current.currentConfig[motionKey];
                let nextValue, transition;
                if (typeof config === 'object' && config !== null) {
                    const { value, ...nextTransition } = config;
                    nextValue = value;
                    transition = nextTransition;
                }
                else {
                    nextValue = config;
                    transition = {};
                }
                const { transition: lastTransition, controls: lastControls } = motionMap.current[motionKey] ?? {};
                const shouldAnimate = (lastTransition &&
                    JSON.stringify(lastTransition) !== JSON.stringify(transition)) ||
                    (currentValue !== undefined && currentValue !== nextValue);
                if (shouldAnimate) {
                    lastControls?.stop();
                    const controls = canvasHandler.current.motionTo(motionKey, nextValue, {
                        ...transition,
                    });
                    motionMap.current[motionKey] = {
                        controls,
                        transition: transition,
                    };
                }
            });
        }
    }, [JSON.stringify(motionConfig)]);
    (0, hook_1.useLayoutEffect)(() => {
        return () => {
            if (motionMap.current) {
                Object.values(motionMap.current).forEach(({ controls }) => {
                    controls.stop();
                });
            }
        };
    }, []);
    return (React.createElement("canvas", { ref: canvasRef, width: width, height: height, ...restProps }));
}));
