import { type Options as MotionOptions } from 'from-to.js';
export interface WaveConfig {
    frequency: number;
    amplitude: number;
    phase?: number;
    speed?: number;
    offset?: number;
    color?: string;
}
export type WaveHandler = ReturnType<typeof createWave>;
export declare const createWave: (canvas: HTMLCanvasElement, config: WaveConfig) => {
    start: () => void;
    setConfig: (config: Partial<WaveConfig>) => void;
    motionTo: <K extends keyof WaveConfig>(key: K, value: WaveConfig[K], options: MotionOptions<WaveConfig[K]>) => import("from-to.js").Controls;
    stop: () => void;
    reset: () => void;
    resize: (width: number, height: number) => void;
    currentConfig: WaveConfig;
};
