"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useWave = exports.useLayoutEffect = void 0;
const React = __importStar(require("react"));
const createWave_1 = require("./createWave");
exports.useLayoutEffect = typeof window !== 'undefined' && window.document
    ? React.useLayoutEffect
    : // eslint-disable-next-line @typescript-eslint/no-empty-function
        () => { };
const useWave = (config, ref) => {
    const { frequency, amplitude, phase, speed, offset, color } = config;
    const canvasRef = React.useRef(null);
    const handler = React.useRef(null);
    (0, exports.useLayoutEffect)(() => {
        if (!handler.current) {
            handler.current = (0, createWave_1.createWave)(canvasRef.current, {
                frequency,
                amplitude,
                phase,
                speed,
                offset,
                color,
            });
            handler.current.start();
        }
        else {
            handler.current.setConfig({
                frequency,
                amplitude,
                phase,
                speed,
                offset,
                color,
            });
        }
    }, [amplitude, color, frequency, offset, phase, speed]);
    (0, exports.useLayoutEffect)(() => {
        if (typeof ref === 'function') {
            ref(handler.current);
            return () => {
                ref(null);
            };
        }
        else if (typeof ref === 'object' && ref !== null && 'current' in ref) {
            ref.current = handler.current;
            return () => {
                ref.current = null;
            };
        }
    }, []);
    (0, exports.useLayoutEffect)(() => {
        return () => {
            handler.current?.stop();
            handler.current = null;
        };
    }, []);
    return [canvasRef, handler];
};
exports.useWave = useWave;
