import * as React from 'react';
import { useWave } from './hook';
export const Wave = React.memo(React.forwardRef((props, ref) => {
    const { width = innerWidth, height = innerHeight, frequency, amplitude, phase, speed, offset, color, ...restProps } = props;
    const [canvasRef] = useWave({
        frequency,
        amplitude,
        phase,
        speed,
        offset,
        color,
    }, ref);
    return (React.createElement("canvas", { ref: canvasRef, width: width, height: height, ...restProps }));
}));
